module.exports = function (readBlock) {
  return function (read) {
    var ended
    var skip = 0
    var length = 0
    var queue = []

    return function source(abort, cb) {
      if (ended) return cb(ended)
      if (ended = abort) return read(ended, function (end) {
        cb(end || true)
      })
      readNext()

      function readNext() {
        if (length <= 0 && skip <= 0) {
          return readBlock(null, function (end, block) {
            if (ended = end) return read(true, function (end) {
              cb(end || true)
            })
            length = block.length || 0
            skip = block.skip || 0
            readNext()
          })
        }
        if (queue.length) next(null, queue.shift())
        else read(null, next)
      }
      function next(end, data) {
        if (ended) return
        if (ended = end) return readBlock(true, function (end) {
          cb(end || true)
        })
        if (skip >= data.length) {
          skip -= data.length
          return read(null, next)
        }
        if (skip > 0) {
          data = data.slice(skip)
          skip = 0
        }
        if (length >= data.length) {
          length -= data.length
          return cb(null, data)
        }
        if (length > 0) {
          var buf = data.slice(0, length)
          queue.push(data.slice(length))
          length = 0
          return cb(null, buf)
        }
        source(null, cb)
      }
    }
  }
}
