var blockFilter = require('.')
var pull = require('pull-stream')
var test = require('tape')

test('empty', function (t) {
  pull(
    pull.once(new Buffer([1])),
    blockFilter(pull.values([])),
    pull.collect(function (err, bufs) {
      t.deepEquals(bufs, [])
      t.end(err)
    })
  )
})

test('big buf', function (t) {
  pull(
    pull.once(new Buffer([1, 5, 7, 4, 2, 7, 5, 9, 8, 1])),
    blockFilter(pull.values([
      {skip: 2, length: 4},
      {skip: 0, length: 0},
      {skip: 1, length: 2}]
    )),
    pull.collect(function (err, bufs) {
      if (err) return t.end(err)
      var buf = Buffer.concat(bufs)
      t.deepEquals(buf, new Buffer([7, 4, 2, 7, 9, 8]))
      t.end()
    })
  )
})

test('small bufs', function (t) {
  pull(
    pull.values([new Buffer([1, 5]), new Buffer([7, 4]), new Buffer([2, 7]),
                 new Buffer([5, 9]), new Buffer([8, 1])]),
    blockFilter(pull.values([{skip: 2, length: 4}, {skip: 1, length: 2}])),
    pull.collect(function (err, bufs) {
      if (err) return t.end(err)
      var buf = Buffer.concat(bufs)
      t.deepEquals(buf, new Buffer([7, 4, 2, 7, 9, 8]))
      t.end()
    })
  )
})
